import * as childProcess from 'child_process';
import * as fs from 'fs';
import * as path from 'path';

const processPath = path.join(__dirname, '../../lib/patcher-installer');

export default function launchProcess(diskFile: string, offset: number, compressedSize: number, decryptionKeys: [number, number, number] | undefined, outputStream: fs.WriteStream) {
  return new Promise((resolve, reject) => {
    const parameters = [
      diskFile,
      offset,
      compressedSize,
    ];
    if (decryptionKeys !== undefined) {
      parameters.push(...decryptionKeys);
    }
    const spawnedProcess = childProcess.spawn(processPath, parameters.map((value) => value.toString(), { cwd: '.' }));

    spawnedProcess.stdout.pipe(outputStream);
    spawnedProcess.stdout.on('end', resolve);

    spawnedProcess.stderr.setEncoding('utf8');
    spawnedProcess.stderr.on('data', reject);
  });
}
